//The ALU of the MIPS
//Kamyar Rafati & Naeem Esfahani

module ALU_mips (A, B, Opcode, y, zero);
	input[31:0]		A, B;
	input[2:0]		Opcode;
	output[31:0]	y;
	output			zero;
	reg[31:0]		y;
	reg				zero;

	always @(A or B or Opcode)
	begin
		case(Opcode)
			0: y = A & B;  //bitwise and
			1: y = A|B;  //bitweise or
			2: y = A+B;  //add
			6: y = A-B;  //subtract
			7: y = A<B;  //SLT
		endcase
	end
	
	always @(y or Opcode)
	begin
		if (Opcode == 5)
		begin
			if (y==0)
				zero = 0;
			else
				zero = 1;
		end
		else
		begin
			if (y==0)
				zero = 1;
			else
				zero = 0;
		end
	end
endmodule
