//Hazard Detection Unit
//Kamyar Rafati & Naeem Esfahani

module Hazard_Detect (Last_IDEX_NOP, ID_Rt, ID_Rs, EX_Rt, EX_MemRead, IFID_Write, PCWrite, IDEX_NOP, reset, clk);
	input[4:0]	ID_Rt, ID_Rs, EX_Rt;
	input		EX_MemRead, reset, clk;
	input		Last_IDEX_NOP;
	output		IFID_Write, PCWrite, IDEX_NOP;
	reg			IFID_Write, PCWrite, IDEX_NOP;
	
	//always @(ID_Rt or ID_Rs or EX_Rt)
	//We must stall pipe for two clocks when we have branch after lw but we assume that we'll have no branch fter lw
	always @(negedge clk)
	begin
		if(reset == 0)
		begin
			if(EX_MemRead && (EX_Rt == ID_Rs || EX_Rt  == ID_Rt) && Last_IDEX_NOP != 0)
				//Stall the pipeline
				begin
					PCWrite = 0;
					IDEX_NOP = 1;
					IFID_Write = 0;
				end
			else
				//Don't Stall the Pipeline
				begin
					PCWrite = 1;
					IDEX_NOP = 0;
					IFID_Write = 1;
				end
		end
		else
		begin
		  PCWrite = 1;
		  IDEX_NOP = 1;
		  IFID_Write = 1;
		end
	end
endmodule
