//Memmory unit
//Kamyar Rafati & Naeem Esfahani

module Memory(address,ind,outd,we, re,clk);
// this is a 4K * 32 memory module, so the address line must be 12 bits
// make sure that test program will not use an address greater than 00000fff
	input[31:0]		address,ind;
	input			re, we,clk;
	output[31:0]	outd;
	reg[31:0]		memory[4095:0];
	reg[31:0]		outd;
	wire			we_clk;
	wire			re_clk;


	assign we_clk = we & clk;
	assign re_clk = re & clk;

	initial
		$readmemh("mem.dat", memory);

// loads a hex code from file mem.dat to the memory, the format for the file 
//is as follows: you specify a 3-bit hex address at each line then 8 bit instruction 
//is followed(start at address 000)

	always @ (posedge re_clk or address)
	begin
		if (re) outd = memory[address];
	end

	always @(negedge we_clk)
	begin
		memory[address] = ind;
	end
endmodule



