//32bit Register
//Kamyar Rafati & Naeem Esfahani

module Reg_32bit (MData, Y, enable, reset, CLK);
	input[31:0]		MData;
	input			CLK, reset, enable;
	output[31:0]	Y;
	reg[31:0]		Y;
	reg[31:0]		Data;
	wire			re_clk;

	assign re_clk = enable & CLK;

	always @(negedge re_clk or MData)
	begin
		if (!reset && enable && !CLK) Data=MData;
	end

	always @(posedge re_clk)
	begin
		Y = Data;
	end

	always @(posedge reset)
	begin
		Data = 0;
	end
endmodule
